SUMMARY = "WebKitBrowser plugin"
LICENSE = "Apache-2.0"
LIC_FILES_CHKSUM = "file://../LICENSE;md5=16cf2209d4e903e4d5dcd75089d7dfe2"

PR = "r1"
PV = "3.0+git${SRCPV}"

S = "${WORKDIR}/git/WebKitBrowser"

SRC_URI = "git://github.com/rdkcentral/rdkservices.git;protocol=git;branch=main\
  file://0001-RDKTV-177-Configure-wpeframework-plugin-startup-orde.patch;patchdir=../ \
  file://0002-Use-SYSLOG-instead-of-TRACE.patch;patchdir=../ \
  file://0003-Increase-browser-creation-timeout.patch;patchdir=../ \
  file://0004-Reduce-BrowserConsoleLog.patch;patchdir=../ \
  file://0005-Enable-mixed-content.patch;patchdir=../ \
  file://0006-Introduce-state-aware-memory-observer.patch;patchdir=../ \
  file://0007-Launch-Metrics-data-collection.patch;patchdir=../ \
"

# Tip of the main at Mar 03, 2023
SRCREV = "4c47eb958b39a22c68c3ffa4a261e0a93351d8f2"

inherit cmake pkgconfig python3native

TOOLCHAIN = "gcc"

DEPENDS += "wpeframework wpeframework-tools-native ${WPEWEBKIT} libsoup-2.4"

PACKAGECONFIG ??= "residentapp searchanddiscoveryapp htmlapp lightningapp aampjsbindings badgerbridge customprocessinfo"

PACKAGECONFIG_append = " ${@bb.utils.contains("DISTRO_FEATURES", "jspp", "jspp","",d)}"

PACKAGECONFIG[debug]                 = "-DCMAKE_BUILD_TYPE=Debug,-DCMAKE_BUILD_TYPE=Release,"
PACKAGECONFIG[residentapp]           = "-DPLUGIN_WEBKITBROWSER_RESIDENT_APP=ON,-DPLUGIN_WEBKITBROWSER_RESIDENT_APP=OFF,"
PACKAGECONFIG[searchanddiscoveryapp] = "-DPLUGIN_WEBKITBROWSER_SEARCH_AND_DISCOVERY_APP=ON,-DPLUGIN_WEBKITBROWSER_SEARCH_AND_DISCOVERY_APP=OFF,"
PACKAGECONFIG[htmlapp]               = "-DPLUGIN_WEBKITBROWSER_HTML_APP=ON,-DPLUGIN_WEBKITBROWSER_HTML_APP=OFF,"
PACKAGECONFIG[lightningapp]          = "-DPLUGIN_WEBKITBROWSER_LIGHTNING_APP=ON,-DPLUGIN_WEBKITBROWSER_LIGHTNING_APP=OFF,"
PACKAGECONFIG[jspp]                  = "-DPLUGIN_WEBKITBROWSER_JSPP=ON,-DPLUGIN_WEBKITBROWSER_JSPP=OFF,"
PACKAGECONFIG[aampjsbindings]        = "-DPLUGIN_WEBKITBROWSER_AAMP_JSBINDINGS=ON,-DPLUGIN_WEBKITBROWSER_AAMP_JSBINDINGS=OFF,aamp"
PACKAGECONFIG[badgerbridge]          = "-DPLUGIN_WEBKITBROWSER_BADGER_BRIDGE=ON,-DPLUGIN_WEBKITBROWSER_BADGER_BRIDGE=OFF,"
PACKAGECONFIG[tzupdate]              = "-DPLUGIN_WEBKITBROWSER_UPDATE_TZ_FROM_FILE=ON,-DPLUGIN_WEBKITBROWSER_UPDATE_TZ_FROM_FILE=OFF,"
PACKAGECONFIG[customprocessinfo]     = "-DPLUGIN_WEBKITBROWSER_CUSTOM_PROCESS_INFO=ON,-DPLUGIN_WEBKITBROWSER_CUSTOM_PROCESS_INFO=OFF,"

BROWSER_MEMORYPROFILE ?= "default"

require include/webkitbrowser_properties.inc
require include/webkitbrowser_memorylimits.${BROWSER_MEMORYPROFILE}.inc

EXTRA_OECMAKE += " \
    -DPYTHON_EXECUTABLE=${STAGING_BINDIR_NATIVE}/python3-native/python3 \
    -DCMAKE_SYSROOT=${STAGING_DIR_HOST} \
    -DBUILD_REFERENCE=${SRCREV} \
    -DBUILD_SHARED_LIBS=ON \
    -DPLUGIN_WEBKITBROWSER=ON \
    -DPLUGIN_WEBKITBROWSER_LOGGING_UTILS=ON \
    -DPLUGIN_WEBKITBROWSER_AUTOSTART="${WEBKITBROWSER_AUTOSTART}" \
    -DPLUGIN_WEBKITBROWSER_MEDIADISKCACHE="${WEBKITBROWSER_MEDIADISKCACHE}" \
    -DPLUGIN_WEBKITBROWSER_MEMORYPRESSURE="${WEBKITBROWSER_MEMORYPRESSURE}" \
    -DPLUGIN_WEBKITBROWSER_MEMORYPROFILE="${WEBKITBROWSER_MEMORYPROFILE}" \
    -DPLUGIN_WEBKITBROWSER_MSEBUFFERS="${WEBKITBROWSER_MSEBUFFERS}" \
    -DPLUGIN_WEBKITBROWSER_STARTURL="${WEBKITBROWSER_STARTURL}" \
    -DPLUGIN_WEBKITBROWSER_DISKCACHE="${WEBKITBROWSER_DISKCACHE}" \
    -DPLUGIN_WEBKITBROWSER_XHRCACHE="${WEBKITBROWSER_XHRCACHE}" \
    -DPLUGIN_WEBKITBROWSER_TRANSPARENT="${WEBKITBROWSER_TRANSPARENT}" \
    -DPLUGIN_WEBKITBROWSER_INJECTEBLE_BUNDLE="${WEBKITBROWSER_INJECTEBLE_BUNDLE}" \
    -DPLUGIN_HTML_APP_LOCALSTORAGESIZE="${HTML_APP_LOCALSTORAGESIZE}" \
    -DPLUGIN_LIGHTNING_APP_LOCALSTORAGESIZE="${LIGHTNING_APP_LOCALSTORAGESIZE}" \
    -DPLUGIN_JSPP_LOCALSTORAGESIZE="${JSPP_LOCALSTORAGESIZE}" \
    -DPLUGIN_SEARCH_AND_DISCOVERY_APP_LOCALSTORAGESIZE="${SEARCH_AND_DISCOVERY_APP_LOCALSTORAGESIZE}" \
    -DPLUGIN_RESIDENT_APP_LOCALSTORAGESIZE="${RESIDENT_APP_LOCALSTORAGESIZE}" \
    -DPLUGIN_WEBKITBROWSER_LOCALSTORAGESIZE="${WEBKITBROWSER_LOCALSTORAGESIZE}" \
    -DPLUGIN_RESIDENT_APP_CLIENTIDENTIFIER="${RESIDENT_APP_CLIENTIDENTIFIER}" \
    -DPLUGIN_RESIDENT_APP_AUTOSTART="${RESIDENT_APP_AUTOSTART}" \
    -DPLUGIN_RESIDENT_APP_STARTURL="${RESIDENT_APP_STARTURL}" \
    -DPLUGIN_RESIDENT_APP_STARTUPORDER="${RESIDENT_APP_STARTUPORDER}" \
    -DPLUGIN_SEARCH_AND_DISCOVERY_APP_CLIENTIDENTIFIER="${SEARCH_AND_DISCOVERY_APP_CLIENTIDENTIFIER}" \
    -DPLUGIN_WEBKITBROWSER_CLIENTIDENTIFIER="${WEBKITBROWSER_CLIENTIDENTIFIER}" \
    -DPLUGIN_HTML_APP_CLIENTIDENTIFIER="${HTML_APP_CLIENTIDENTIFIER}" \
    -DPLUGIN_LIGHTNING_APP_CLIENTIDENTIFIER="${LIGHTNING_APP_CLIENTIDENTIFIER}" \
    -DPLUGIN_JSPP_CLIENTIDENTIFIER="${JSPP_CLIENTIDENTIFIER}" \
    -DPLUGIN_HTML_APP_LOCALSTORAGE="${HTML_APP_LOCALSTORAGE}" \
    -DPLUGIN_HTML_APP_COOKIESTORAGE="${HTML_APP_LOCALSTORAGE}" \
    -DPLUGIN_LIGHTNING_APP_LOCALSTORAGE="${LIGHTNING_APP_LOCALSTORAGE}" \
    -DPLUGIN_LIGHTNING_APP_COOKIESTORAGE="${LIGHTNING_APP_LOCALSTORAGE}" \
    -DPLUGIN_JSPP_LOCALSTORAGE="${JSPP_LOCALSTORAGE}" \
    -DPLUGIN_JSPP_COOKIESTORAGE="${JSPP_LOCALSTORAGE}" \
    -DPLUGIN_SEARCH_AND_DISCOVERY_APP_LOCALSTORAGE="${SEARCH_AND_DISCOVERY_APP_LOCALSTORAGE}" \
    -DPLUGIN_SEARCH_AND_DISCOVERY_APP_COOKIESTORAGE="${SEARCH_AND_DISCOVERY_APP_LOCALSTORAGE}" \
    -DPLUGIN_RESIDENT_APP_LOCALSTORAGE="${RESIDENT_APP_LOCALSTORAGE}" \
    -DPLUGIN_RESIDENT_APP_COOKIESTORAGE="${RESIDENT_APP_LOCALSTORAGE}" \
    -DPLUGIN_WEBKITBROWSER_DISKCACHEDIR="${WEBKITBROWSER_DISKCACHEDIR}" \
    -DPLUGIN_RESIDENT_APP_DISKCACHEDIR="${RESIDENT_APP_DISKCACHEDIR}" \
    -DPLUGIN_SEARCH_AND_DISCOVERY_APP_DISKCACHEDIR="${SEARCH_AND_DISCOVERY_APP_DISKCACHEDIR}" \
    -DPLUGIN_LIGHTNING_APP_DISKCACHEDIR="${LIGHTNING_APP_DISKCACHEDIR}" \
    -DPLUGIN_JSPP_DISKCACHEDIR="${JSPP_DISKCACHEDIR}" \
    -DPLUGIN_HTML_APP_DISKCACHEDIR="${HTML_APP_DISKCACHEDIR}" \
    -DPLUGIN_SEARCH_AND_DISCOVERY_APP_SECURE="${SEARCH_AND_DISCOVERY_APP_SECURE}" \
    -DPLUGIN_RESIDENT_APP_SECURE="${RESIDENT_APP_SECURE}" \
    -DPLUGIN_HTML_APP_SECURE="${HTML_APP_SECURE}" \
    -DPLUGIN_LIGHTNING_APP_SECURE="${LIGHTNING_APP_SECURE}" \
    -DPLUGIN_JSPP_SECURE="${JSPP_SECURE}" \
    -DPLUGIN_WEBKITBROWSER_SECURE="${WEBKITBROWSER_SECURE}" \
    -DPLUGIN_HTML_APP_PERSISTENTPATHPOSTFIX="${HTML_APP_PERSISTENTPATHPOSTFIX}" \
    -DPLUGIN_LIGHTNING_APP_PERSISTENTPATHPOSTFIX="${LIGHTNING_APP_PERSISTENTPATHPOSTFIX}" \
    -DPLUGIN_JSPP_PERSISTENTPATHPOSTFIX="${JSPP_PERSISTENTPATHPOSTFIX}" \
    -DPLUGIN_RESIDENT_APP_PERSISTENTPATHPOSTFIX="${RESIDENT_APP_PERSISTENTPATHPOSTFIX}" \
    -DPLUGIN_SEARCH_AND_DISCOVERY_APP_PERSISTENTPATHPOSTFIX="${SEARCH_AND_DISCOVERY_APP_PERSISTENTPATHPOSTFIX}" \
    -DPLUGIN_WEBKITBROWSER_PERSISTENTPATHPOSTFIX="${WEBKITBROWSER_PERSISTENTPATHPOSTFIX}" \
    -DPLUGIN_SEARCH_AND_DISCOVERY_APP_MEMORYPRESSURE="${SEARCH_AND_DISCOVERY_APP_MEMORYPRESSURE}" \
    -DPLUGIN_RESIDENT_APP_MEMORYPRESSURE="${RESIDENT_APP_MEMORYPRESSURE}" \
    -DPLUGIN_HTML_APP_MEMORYPRESSURE="${HTML_APP_MEMORYPRESSURE}" \
    -DPLUGIN_LIGHTNING_APP_MEMORYPRESSURE="${LIGHTNING_APP_MEMORYPRESSURE}" \
    -DPLUGIN_HTML_APP_COMPOSITOR="${HTML_APP_COMPOSITOR}" \
    -DPLUGIN_LIGHTNING_APP_COMPOSITOR="${LIGHTNING_APP_COMPOSITOR}" \
    -DPLUGIN_JSPP_MEMORYPRESSURE="${JSPP_MEMORYPRESSURE}" \
    -DPLUGIN_JSPP_STARTURL="${JSPP_STARTURL}" \
    -DPLUGIN_JSPP_DISKCACHE="${JSPP_DISKCACHE}" \
    -DPLUGIN_JSPP_WEBINSPECTOR_ADDRESS="${JSPP_WEBINSPECTOR_ADDRESS}" \
    -DPLUGIN_JSPP_LOCALSTORAGE_ENABLE="${JSPP_LOCALSTORAGE_ENABLE}" \
"

FILES_SOLIBSDEV = ""
FILES_${PN} += "${libdir}/wpeframework/plugins/*.so ${libdir}/*.so ${datadir}/WPEFramework/*"
FILES_${PN}-dbg += "${datadir}/WPEFramework/WebKitBrowser/.debug"

INSANE_SKIP_${PN} += "libdir staticdev dev-so"
INSANE_SKIP_${PN}-dbg += "libdir"
